{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE TypeSynonymInstances #-}
module Format where

import Data.Sequence (Seq)
import qualified Data.Sequence as Seq
import qualified Data.Foldable as F
import Data.Foldable (Foldable)
import Data.List

class Format a where
  format :: a -> String

instance Format String where
  format = id

instance (Foldable f, Format a) => Format (f a) where
  format = concat . (["["] ++) . (++ ["]"]) . intersperse ", " . map format . F.toList
