{-# LANGUAGE NamedFieldPuns #-}
module IdDB.ConstructorGraphDebug
( dotifyConstructorGraph
) where

import IdDB.ConstructorGraph
import Data.Graph.Inductive hiding (mkNode, mkEdge)
import Data.GraphViz
import Type
import DataCon
import Format
import Util.GHC
import Outputable (showPpr)

dotifyConstructorGraph :: ConstructorGraph a -> String
dotifyConstructorGraph = printDotGraph . (\gr -> graphToDot True gr [] mkNode mkEdge) . theGraph

mkNode :: (Node, (Type, Integer)) -> [Attribute]
mkNode ti = [Label (StrLabel (show ti))]

mkEdge :: (Node, Node, [(DataCon, Int)]) -> [Attribute]
mkEdge (_,_,xs) = [Label (StrLabel (showPpr xs))]

