{-# LANGUAGE NamedFieldPuns #-}
module IdDB.TypeMapDebug where

import Outputable
import IdDB.TypeMap

instance Outputable a => Outputable (AbsTypeMap a) where
  ppr (ATM node _) = text "ATM" <+> parens (ppr node)

instance Outputable a => Outputable (TypeMapNode a) where
  ppr Empty    = text "ε"
  ppr Split { tyVars , appTys , tyCons , funTys , forallTys } 
    = hang (text "☼") 1 (vcat [tyVarsD, appTysD, tyConsD, funTysD, forallTysD])
    where
      tyVarsD    = text "α ↦" <+> (nest 1 (ppr tyVars))
      appTysD    = text "∘ ↦" <+> (nest 1 (ppr appTys))
      tyConsD    = text "T ↦" <+> (nest 1 (ppr tyCons))
      funTysD    = text "→ ↦" <+> (nest 1 (ppr funTys))
      forallTysD = text "∀ ↦" <+> (nest 1 (ppr forallTys))

instance Outputable a => Outputable (TypeMapPath a) where
  ppr Stop = text "!"
  ppr Step { stopsHere , carrysOn }
    = hang (text "»") 1 (vcat [stopsHereD, carrysOnD])
      where
        stopsHereD = text "! ↦" <+> (nest 1 (ppr stopsHere))
        carrysOnD  = text "» ↦" <+> (nest 1 (ppr carrysOn))
