module Main where

import System.FilePath.Find
import System.Environment
import Control.Applicative
import Control.Monad
import System.Process
import Data.Monoid
import Data.Maybe
import Data.List hiding (find)

main :: IO ()
main = do
  args <- getArgs

  subdirs <- case args of
              [] -> find always (contains "Tests.hs") "tests"
              _  -> find always ((contains "Tests.hs") &&?  ((flip any args . flip isInfixOf) `liftM` filePath)) "tests"

  let command subdir = proc "ghc" ["-itests"
                                  , "-i" ++ subdir
                                  , "Tests"
                                  , "TestRunner"
                                  , "-e", "TestRunner.run" ++ show subdir ++ " tests"
                                  ]

  forM_ subdirs $ \subdir -> do
    putStrLn subdir
    (_, _, _, ph) <- createProcess (command subdir)
    waitForProcess ph
