{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE ViewPatterns #-}

module RandomPlayer where

import Data.Set (Set)
import qualified Data.Set as Set
import System.Random
import Player
import Board
import Control.Applicative

newtype RandomPlayer = RP StdGen

instance (Monad m) => Player m RandomPlayer where
  getMove (availablePositions -> aps) (RP g)
    = return $ (pos, RP g')
    where
      (i, g') = randomR (0, pred $ Set.size aps) g
      pos = (Set.toAscList aps) !! i

randomPlayer :: RandomPlayer
randomPlayer = RP (mkStdGen 1001)

reallyRandomPlayer :: IO RandomPlayer
reallyRandomPlayer = RP <$> newStdGen
