{-# LANGUAGE MagicHash #-}
module Engine.NewtypeStableNameTests where

import Test.HUnit

import Engine.EngineHValue
import GHC.Prim
import TysWiredIn

data Foo = Foo
newtype Bar = Bar Foo


foo1 = id Foo
bar1 = id (Bar foo1)

tests = "NewtypeStableNameTests" ~: [test test1]

test1 = do
  hv1 <- mkEngineHValue (unsafeCoerce# foo1) boolTy
  hv2 <- mkEngineHValue (unsafeCoerce# bar1) charTy

  (toStableName hv1) == (toStableName hv2) @? "Newtype different HValues are actually the same!"

  hv1 /= hv2 @? "Engine HValues however are not the same!"
