module Plan.ExperimentMapTest where

import qualified Plan.ExperimentMap as M
import Plan.ExperimentMap (Map)
import Plan.ExperimentMapTestLib

test 0 = check $ do
  M.lookup undefined M.empty `is` Nothing

test 1 = check $ do
  let m1 = M.insert exp1 0 M.empty
  M.lookup exp1 m1 `is` Just 0
  M.lookup exp2 m1 `is` Nothing

test 2 = check $ do
  let m1 = M.insert exp1 0 M.empty
  let m2 = M.insert exp1 1 m1

  M.lookup exp1 m2 `is` Just 1

test 3 = check $ do
  let m1 = M.insert exp1 0 M.empty
  let m2 = M.insert exp2 1 m1
  let m3 = M.delete exp1 m2

  M.lookup exp1 m3 `is` Nothing
  M.lookup exp2 m3 `is` Just 1

test _ = notWrittenYet

tests = "ExperimentMapTest" ~: buildTests test
